--Константы
UpdateInterval = 20; --Миллисекунды, минимальный интервал между обновлением
-----------

HelperEnabled = true;
SpellCodes={}
InitComplite= false;
Timers = {}
LastTarget = nil;
GuiTop = -2;
GuiLeft = 500;
GuirelativePoint = "TOPLEFT";
NEEDOFF = false;
NEEDON = false;


function OnUpdate(self, elapsed)	
	if (not InitComplite) then
		Init();
	end	

	ReCalcTimers(elapsed);
	UpdateGUI();

	if NEEDOFF and Timers["NEEDOFF"] == nil then
			NEEDOFF = false;
			HelperEnabled = false;
	end

	if NEEDON and Timers["NEEDON"] == nil then
			NEEDON = false;
			HelperEnabled = true;
	end
	
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;
	local UpdateIntervalSeconds = UpdateInterval / 1000;
	
	if (self.TimeSinceLastUpdate > UpdateIntervalSeconds) then
		MainScan();
		self.TimeSinceLastUpdate = self.TimeSinceLastUpdate % UpdateIntervalSeconds;
	end;
end

function ReCalcTimers(elapsed)
	function ReCalcTime(Time, elapsed)
		if (Time == nil) then
			return nil;
		end
		
		if (Time ~= 0) then
			Time = Time - elapsed;
		end
		
		if (Time < 0) then
			Time = nil;
		end
		
		return Time;
	end

	table.foreach(Timers, function(k,v) Timers[k] = ReCalcTime(Timers[k], elapsed) end);

	GuirelativePoint, _, _, GuiLeft, GuiTop = GuiFrame:GetPoint()
end


function RemoveBindings()

	for i, key in ipairs(keys) do
		for Mod =0,6 do
			local prefix = "none";
			if Mod == 0 then prefix = "CTRL-"
				elseif Mod == 1 then prefix = "ALT-"
				elseif Mod == 2 then prefix = "SHIFT-"
				elseif Mod == 3 then prefix = "ALT-SHIFT-"
				elseif Mod == 4 then prefix = "CTRL-SHIFT-"
				elseif Mod == 5 then prefix = "ALT-CTRL-"
			end	
			
			local HotKey = prefix..key;
			local action = GetBindingByKey(HotKey)
			if (action ~= nil) then
				if (string.find(action, "ButtonForMacro") or string.find(action, "ButtonForSpell")  or string.find(action, "BlackDps")) then
					local passed = 0
					local key1, key2 = GetBindingKey(action);
					if (key1) then
						if (key1 == HotKey) then passed = 1; end; end;
					if (key2) then
						if (key2 == HotKey) then passed = 1; end; end;
					if passed == 1 then 
						if (blackdpsBindingDebug == 1) then print("remove "..action.." "..HotKey) end
						local ret = SetBinding(HotKey, nil)
						--if (blackdpsBindingDebug == 1) then print(ret) end
					end

				end			
			end	
		end
	end
end

function Init()
		InitComplite= true;
		print("Старт системы поддержки решения");
		RemoveBindings();
		SaveBindings(GetCurrentBindingSet());
		CreateControlButtons();
		InitCommands();
		CreateGUI();
		SaveBindings(GetCurrentBindingSet());
		print("Инициализация завершена");
		
		print("Состояние переключателей:");

		FTumblerState("F1", F1Tumbler);
		FTumblerState("F2", F2Tumbler);
		FTumblerState("F3", F3Tumbler);
		FTumblerState("F4", F4Tumbler);		
		FTumblerState("M", AutoMountTumbler);
		FTumblerState("F", FindlyaTumbler);	
		FTumblerState("A", AutoAttackTumbler);	
			
end


WallBlockFrame = CreateFrame("FRAME", nil, UIParent)
--CantHealYouFrame:Hide()

WallBlockFrame:SetScript("OnEvent", WallBlock_OnEvent)
WallBlockFrame:RegisterEvent("UI_ERROR_MESSAGE")

function WallBlock_OnEvent(self, event, arg1, arg2, arg3, arg4)
	if (arg1 == SPELL_FAILED_LINE_OF_SIGHT) and (LastTarget ~= nil) then
		print("WallBlock"..LastTarget);
		Timers["WallBlock"..LastTarget] = 0.6;
		Timers["WallBlock"..UnitGUID(LastTarget)] = 0.6;
	end
end



local lasts1 = 0;

function ResizeCMD()
		--local s1 = 768/string.match(({GetScreenResolutions()})[GetCurrentResolution()], "%d+x(%d+)");
		local s1 = 1.0*GetScreenHeight()/28;
		if s1 == lasts1 then return end
		cmdbtn0:SetWidth(s1)
		cmdbtn0:SetHeight(s1)
		cmdbtn1:SetWidth(s1)
		cmdbtn1:SetHeight(s1)
		cmdbtn1:SetPoint("TOPLEFT", s1, 0)		
		lasts1 = s1
end


local Findlya = false;
function MainScan()
	if (Timers["LastTarget"] == nil) then
		LastTarget = nil;
	end

	if (UnitAffectingCombat("player")) then
		Findlya = true;
	end

	if FindlyaTumbler then
		if (UnitCastingInfo("player")=="Собиратель трофеев") or (GetItemLastCD("Собиратель трофеев Финдля") > 2) then
			Findlya = false;
		end
	end
	
	if (not HelperEnabled) then
		txtCommand:SetTextColor(0.5, 0.5, 0.5);
		txtCommand:SetText("-");
		return; 
	end;
	ResizeCMD()

	local spell, target = SpellSelector();

	if (GetSpellInfo(spell) ~= nil and UnitChannelInfo("player") == GetSpellInfo(spell)) then
		spell = nil;
		target = nil;
	end
	
	if FindlyaTumbler then
		if ((spell == nil) and (not UnitAffectingCombat("player")) and Findlya and (UnitCastingInfo("player")== nil) and (GetUnitSpeed("player") == 0)) then
			spell = "Собиратель трофеев Финдля";
			target = "player";
		end
	end
	

	if AutoAttackTumbler then
		if ((spell == nil) and (not IsCurrentSpell(6603)) and ((MyIsSpellInRange(75, "target") == 1) or CheckInteractDistance("target", 3)) and IsHarmUnit("target")) then
			spell = "Автоатака";
			target = "target";
		end
	end


	if (spell == nil) then
		if (Timers["ShowSpell"] == nil) then
			txtCommand:SetTextColor(0.5, 0.5, 0.5);
			txtCommand:SetText("-");
		end
	else
		txtCommand:SetTextColor(1, 1, 1);
		spellname = GetSpellInfo(spell);
		if (spellname ~= nil) then
			txtCommand:SetText(target..": "..spellname);
		else
			txtCommand:SetText(target..": "..spell);
		end
		Timers["ShowSpell"] = 2;		
	end

	
	if (target ~= nil) then
		LastTarget = target;
		Timers["LastTarget"] = 1;
	end
	
	if (IsCurrentSpell(spell) == 1) then
		SendData(nil, nil);
		return
	end
	


	local TargetSpell = nil;
	if ((target ~= nil) and (UnitGUID(target) ~= UnitGUID("focus"))) then
		TargetSpell = "Focus"..target;	
	end

	SendData(TargetSpell, spell);
	
	if (spell == nil) then
		AutoMount();
	end
end

function MyRaidRole(unit)
	--local raidIndex = UnitInRaid(unit);
	--if (raidIndex == nil) then return "NONE"; end;
	--local name, rank, subgroup, level, class, fileName,  zone, online, isDead, role, isML = GetRaidRosterInfo(raidIndex);
	--return role; --DAMAGER TANK HEALER
	return UnitGroupRolesAssigned(unit);
end

function AutoMount()
	if (UnitCastingInfo("player")~= nil) and ((Timers["antimount"] == nil) or (Timers["antimount"] < 1)) then
		Timers["antimount"] = 1.5;
	end
	
	if (IsMounted()) then
		Timers["antimount"] = 2;
	end
	

	if (AutoMountTumbler and (Timers["antimount"] == nil) and (GetLootMethod() ~= nil) and (GetUnitSpeed("player") == 0) and (not UnitAffectingCombat("player")) and IsOutdoors() and (not IsMounted())) then
		if (C_MountJournal.Summon ~= nil) then
			C_MountJournal.Summon(0)
		else
			C_MountJournal.SummonByID(0)
		end
	end

end

function CreateFontString(x, y, text)
	NewFontString = GuiFrame:CreateFontString(nil, "OVERLAY")
	NewFontString:SetFont("Fonts\\FRIZQT__.TTF", 14, "OUTLINE")
	NewFontString:SetPoint("TOPLEFT", GuiFrame, "TOPLEFT", x, y);
	NewFontString:SetText(text);
	return NewFontString;
end

function CreateGUI()
	GuiFrame  = CreateFrame("Frame", "AnimorHistoryFrame", UIParent)

	GuiFrame:SetMovable(true)
	GuiFrame:EnableMouse(true)
	GuiFrame:RegisterForDrag("LeftButton")
	GuiFrame:SetScript("OnDragStart", GuiFrame.StartMoving)
	GuiFrame:SetScript("OnDragStop", GuiFrame.StopMovingOrSizing)

	GuiFrame.width  = 208
	GuiFrame.height = 48
	GuiFrame:SetFrameStrata("HIGH")
	GuiFrame:SetSize(GuiFrame.width, GuiFrame.height)
	GuiFrame:SetPoint(GuirelativePoint, UIParent, GuirelativePoint, GuiLeft, GuiTop)
	GuiFrame:SetBackdrop({
		bgFile   = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile     = true,
		tileSize = 12,
		edgeSize = 12,
		insets   = { left = 2, right = 2, top = 2, bottom = 2 }
	})
	HelperEnabledColorInverter = false;
	GuiFrame:SetBackdropColor(0, 0, 0, 1)

	txtF1Tumbler = CreateFontString(6, -6, "F1");
	txtF2Tumbler = CreateFontString(28, -6, "F2");
	txtF3Tumbler = CreateFontString(50, -6, "F3");
	txtF4Tumbler = CreateFontString(72, -6, "F4");
	txtAutoMountTumbler = CreateFontString(100, -6, "M");
	txtFindlyaTumbler = CreateFontString(120, -6, "F");
	txtAutoAttackTumbler  = CreateFontString(136, -6, "A");

	txtCommand = CreateFontString(6, -26, "-");
	txtCommand:SetTextColor(0.5, 0.5, 0.5);

	
	if version7() then
		cmdbtn0:SetFrameStrata("HIGH")
		cmdbtn1:SetFrameStrata("HIGH")
	end
end

function UpdateGUI()
	if (HelperEnabled) then
		GuiFrame:SetBackdropColor(0, 0, 0, 1)	
	else
		if (Timers["HelperEnabledColorInverter"] == nil) then
			Timers["HelperEnabledColorInverter"] = 0.6;
			HelperEnabledColorInverter = not HelperEnabledColorInverter;
		end
		if (HelperEnabledColorInverter) then
			GuiFrame:SetBackdropColor(1, 0.05, 0.05, 1)			
		else
			GuiFrame:SetBackdropColor(0, 0, 0, 1)		
		end
	end
	UpdateTumblerColor(txtF1Tumbler, F1Tumbler);
	UpdateTumblerColor(txtF2Tumbler, F2Tumbler);
	UpdateTumblerColor(txtF3Tumbler, F3Tumbler);
	UpdateTumblerColor(txtF4Tumbler, F4Tumbler);
	UpdateTumblerColor(txtAutoMountTumbler, AutoMountTumbler);
	UpdateTumblerColor(txtFindlyaTumbler, FindlyaTumbler);
	UpdateTumblerColor(txtAutoAttackTumbler, AutoAttackTumbler);
	
end

function UpdateTumblerColor(Tumbler, State)
	if (State) then
		Tumbler:SetTextColor(0, 1, 0);
	else	
		Tumbler:SetTextColor(0.5, 0.5, 0.5);
	end
end

function MyUnitAura(unit, SpellName, unitCasterCheckType, mode, aurafilter)
--mode
--0 - RemainTime
--1 - Count

	for i=1,40 do
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, canStealOrPurge, shouldConsolidate, spellId, canApplyAura, isBossDebuff, isCastByPlayer = UnitAura(unit, i, aurafilter)
	
		if not name then 
			break
		end
	
		if string.upper(name) == string.upper(SpellName) 
			and (
					(unitCasterCheckType == 0) or
					(unitCasterCheckType == 1 and UnitIsUnit("player", unitCaster)) or
					(unitCasterCheckType == 2 and not UnitIsUnit("player", unitCaster))
				) then 
					if     mode == 0 then return expirationTime - GetTime();
					elseif mode == 1 then return count end					
				end
	end

	return 0;
end

function GetDebuffRemainTime(unit, SpellName, unitCasterCheckType)
	return MyUnitAura(unit, SpellName, unitCasterCheckType, 0, "HARMFUL");
end

function GetDebuffCount(unit, SpellName, unitCasterCheckType)
	return MyUnitAura(unit, SpellName, unitCasterCheckType, 1, "HARMFUL");
end

function GetBuffRemainTime(unit, SpellName, unitCasterCheckType)
	return MyUnitAura(unit, SpellName, unitCasterCheckType, 0, "HELPFUL");
end

function GetBuffCount(unit, SpellName, unitCasterCheckType)
	return MyUnitAura(unit, SpellName, unitCasterCheckType, 1, "HELPFUL");
end


function GetLastCD(SpellName)
	local start, duration, enabled = GetSpellCooldown(SpellName);
	if (start == nil) then
		return 0;
	end
	if (start <= 0)  then
		return 0;
	end
	return duration - (GetTime() - start);
end

function CanCast(SpellName, InMoving)
	local speed, runSpeed, flightSpeed, swimSpeed = GetUnitSpeed("player");
	local name, rank, icon, castTime, minRange, maxRange = GetSpellInfo(SpellName)
	local start, duration, enabled = GetSpellCooldown(SpellName);
	local usable, nomana = IsUsableSpell(SpellName);
	return ((GetLastCD(SpellName) <= 0.4) or (duration == 0)) and usable and (not nomana) and enabled and (InMoving or not ((speed ~= 0) and (castTime > 0)));
end

function CanCastHarm(SpellName, unit, InMoving)
	return CanCastUnit(SpellName, unit) and IsHarmUnit(unit);
end
function IsHarmUnit(unit)
	return  UnitCanAttack("player", unit)
end

SpellNotFound={}
function CanCastUnit(SpellName, Unit, InMoving)
	if (GetSpellIdInBook(SpellName) == nil) then
		if (SpellNotFound[SpellName] == nil) then
			print("Способность "..SpellName.." не найдена в книге заклинаний")
			SpellNotFound[SpellName] = 1
		end
		return false;
	end
	return UnitIsVisible(Unit) and UnitExists(Unit) and (not UnitIsDeadOrGhost(Unit)) and  (Timers["WallBlock"..UnitGUID(Unit)] == nil) and CanCast(SpellName, InMoving) and (MyIsSpellInRange(SpellName, Unit) == 1);
end

function MyIsSpellInRange(SpellName, Unit)
 	if not (UnitIsVisible(Unit) and UnitExists(Unit)) then return 0; end

	SpellIdInBook, BookName = GetSpellIdInBook(SpellName)
	if (SpellIdInBook == nil) then return 0 end;
 
 
	local name, rank, icon, castTime, minRange, maxRange = GetSpellInfo(SpellName);
	local inRange = IsSpellInRange(SpellIdInBook, BookName, Unit);
	if (inRange == nil) or (inRange == 1) then
		return 1;
	end
	return 0;
end

function MyGetSpecializationName()
	local currentSpec = GetSpecialization();
	return currentSpec and select(2, GetSpecializationInfo(currentSpec)) or "None"
end

function GetSpellIdInBook(SpellName)
	_, _, _, _, _, _, spellID = GetSpellInfo(SpellName)
	local numTabs = GetNumSpellTabs();
	for i=1,numTabs do 
		local name,texture,offset,numSpells = GetSpellTabInfo(i) 
		for i2=offset+1,offset + numSpells do 
			_, _, _, _, _, _, CspellID = GetSpellInfo(i2, name)
			if CspellID == spellID then return i2, name; end
		end
	end
end


function MyCastTime(SpellName)
	local name, rank, icon, castTime, minRange, maxRange = GetSpellInfo(SpellName)
	if (name == nil) then
		return 0;
	end
	return castTime;
end

function MyGetShapeshiftForm(CheckIndex)
	if GetShapeshiftForm(nil) == CheckIndex  then
		return 1;
	else
		return 0;
	end
end


function CheckDamagedAllyCount(Health)
	local result = 0;
	if UnitExists("player") and (not UnitIsDeadOrGhost("player")) and ((UnitHealth("player")/UnitHealthMax("player")*100)<=Health) then
		result = result + 1;
	end

	if UnitExists("raid1") then
	    for i = 1, 40, 1 do
			local Unit = "raid"..i;
			if UnitExists(Unit) and (not UnitIsDeadOrGhost(Unit)) and ((UnitHealth(Unit)/UnitHealthMax(Unit)*100)<=Health) then
				result = result + 1;
			end
		end
	else
	    for i = 1, 4, 1 do
			local Unit = "party"..i;
			if UnitExists(Unit) and (not UnitIsDeadOrGhost(Unit)) and ((UnitHealth(Unit)/UnitHealthMax(Unit)*100)<=Health) then
				result = result + 1;
			end
		end
	end
	return result;
end


function FSortUnitsByHP(a,b) 
  if not UnitExists(a) and not UnitExists(b) then
    return false
  end
  if not UnitExists(a) then
    return false
  end
  if not UnitExists(b) then
    return true
  end  

	return (UnitHealth(a)/UnitHealthMax(a))<(UnitHealth(b)/UnitHealthMax(b)) 
end

function SortUnitsByHP(units)
	 table.sort(units, FSortUnitsByHP)
	 return units;
end



function MyUnitsCompared(unit1, unit2)
	if (UnitGUID(unit1) == UnitGUID(unit2)) 
	then 
		return 1
	else
		return 0
	end
end

function MyHaveTotem(slot)
	local haveTotem, name, startTime, duration, icon = GetTotemInfo(slot);
	if haveTotem then 
		return 1
	else
		return 0
	end
end

function CalcCastingFinish(endTime)
	return endTime/1000 - GetTime();
end


function MyCastRemain(unit, CastType, checkspell)
	local spell1, _, _, _, _, endTime1 = UnitCastingInfo(unit)
	local spell2, _, _, _, _, endTime2 = UnitChannelInfo(unit)

	if spell1 and (CastType == 0 or CastType == 2) and (checkspell == nil or string.upper(checkspell) == string.upper(spell1)) then return CalcCastingFinish(endTime1); end
	if spell2 and (CastType == 1 or CastType == 2) and (checkspell == nil or string.upper(checkspell) == string.upper(spell2)) then return CalcCastingFinish(endTime2); end

	return 0;
end

function MyRuneCD(i)
			local start, duration, runeReady = GetRuneCooldown(i);
			if runeReady then return 0 end
			return (duration - (GetTime() - start))
end

function MyRunesCheck(CheckTypeID, CDTypeID)
	local result = 0;
	local ready = 0;
	local incd = 0;
	local empty = 0;
	for i = 1, 6 do
		if CheckTypeID == 0 or GetRuneType(i) == CheckTypeID then
			local MyRuneCDresult = MyRuneCD(i);
			if (MyRuneCDresult == 0) then
				ready = ready + 1
			else
				local mirrorrune;
				if i == 1 then mirrorrune = 2 end
				if i == 2 then mirrorrune = 1 end
				if i == 3 then mirrorrune = 4 end
				if i == 4 then mirrorrune = 3 end
				if i == 5 then mirrorrune = 6 end
				if i == 6 then mirrorrune = 5 end
				local mirrorruneRuneCDresult = MyRuneCD(mirrorrune);
				if (mirrorruneRuneCDresult ~= 0 and mirrorruneRuneCDresult < MyRuneCDresult) then
					empty = empty + 1
				else
					incd = incd + 1
				end
			end
	   end
	end
	
	--print ("Готовых "..ready);
	--print ("Кулдаун "..incd);
	--print ("Пустых "..empty);

	if CDTypeID == 0 then return ready; end
	if CDTypeID == 1 then return empty; end
	if CDTypeID == 2 then return incd; end
	if CDTypeID == 3 then return incd+empty; end
	return 0;
end

ItemNotFound={};
function GetItemLastCD(ItemName)
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(ItemName)

	if (itemName == nil) then
		if (ItemNotFound[ItemName] == nil) then
			print("Предмет "..ItemName.." не найден")
			ItemNotFound[ItemName] = 1
		end
		return 9999;
	end

	local _, _, Color, Ltype, ItemId, Enchant, Gem1, Gem2, Gem3, Gem4, Suffix, Unique, LinkLvl, Name = string.find(itemLink,    "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
	local start, duration, enable = GetItemCooldown(ItemId);
	if start == 0 then return 0; end
	return duration-(GetTime()-start);
end




function CreateControlButtons()
	local ButtonF1Tumbler = CreateFrame("Button", "ButtonF1Tumbler", UIParent, "SecureActionButtonTemplate");		
	SetBindingClick("F1", "ButtonF1Tumbler");	
	ButtonF1Tumbler:SetScript("OnClick", ButtonF1TumblerClick);	

	local ButtonF2Tumbler = CreateFrame("Button", "ButtonF2Tumbler", UIParent, "SecureActionButtonTemplate");		
	SetBindingClick("F2", "ButtonF2Tumbler");	
	ButtonF2Tumbler:SetScript("OnClick", ButtonF2TumblerClick);	

	local ButtonF3Tumbler = CreateFrame("Button", "ButtonF3Tumbler", UIParent, "SecureActionButtonTemplate");		
	SetBindingClick("F3", "ButtonF3Tumbler");	
	ButtonF3Tumbler:SetScript("OnClick", ButtonF3TumblerClick);	

	local ButtonF4Tumbler = CreateFrame("Button", "ButtonF4Tumbler", UIParent, "SecureActionButtonTemplate");		
	SetBindingClick("F4", "ButtonF4Tumbler");	
	ButtonF4Tumbler:SetScript("OnClick", ButtonF4TumblerClick);	
	
	local ButtonAutoMountTumbler = CreateFrame("Button", "ButtonAutoMountTumbler", UIParent, "SecureActionButtonTemplate");		
	SetBindingClick("F5", "ButtonAutoMountTumbler");	
	ButtonAutoMountTumbler:SetScript("OnClick", ButtonAutoMountTumblerClick);

	local ButtonFindlyaTumbler = CreateFrame("Button", "ButtonFindlyaTumbler", UIParent, "SecureActionButtonTemplate");		
	SetBindingClick("F6", "ButtonFindlyaTumbler");	
	ButtonFindlyaTumbler:SetScript("OnClick", ButtonFindlyaTumblerClick);

	local ButtonFindlyaTumbler = CreateFrame("Button", "ButtonAutoAttackTumbler", UIParent, "SecureActionButtonTemplate");		
	SetBindingClick("F7", "ButtonAutoAttackTumbler");	
	ButtonFindlyaTumbler:SetScript("OnClick", ButtonAutoAttackTumblerClick);

	local ButtonTumbler = CreateFrame("Button", "ButtonTumbler", UIParent, "SecureActionButtonTemplate");		
	SetBindingClick("F9", "ButtonTumbler");	
	ButtonTumbler:SetScript("OnClick", ButtonTumblerClick);	
	
	local ButtonReloadUI = CreateFrame("Button", "ButtonReloadUI", UIParent, "SecureActionButtonTemplate");		
	SetBindingClick("F9", "ButtonReloadUI");	
	ButtonReloadUI:SetScript("OnClick", ButtonReloadUIClick);		
end

F1Tumbler = false;
F2Tumbler = false;
F3Tumbler = false;
F4Tumbler = false;
AutoMountTumbler = false;
FindlyaTumbler = false;

function ButtonF1TumblerClick()
	if (F1Tumbler) then
		F1Tumbler = false;
	else
		F1Tumbler = true;
	end
	FTumblerState("F1", F1Tumbler);
end


function ButtonF2TumblerClick()
	if (F2Tumbler) then
		F2Tumbler = false;
	else
		F2Tumbler = true;
	end
	FTumblerState("F2", F2Tumbler);
end


function ButtonF3TumblerClick()
	if (F3Tumbler) then
		F3Tumbler = false;
	else
		F3Tumbler = true;
	end
	FTumblerState("F3", F3Tumbler);
end

function ButtonF4TumblerClick()
	if (F4Tumbler) then
		F4Tumbler = false;
	else
		F4Tumbler = true;
	end
	FTumblerState("F4", F4Tumbler);
end

function ButtonAutoMountTumblerClick()
	AutoMountTumbler = not AutoMountTumbler;
	FTumblerState("AutoMount", AutoMountTumbler);
end

function ButtonFindlyaTumblerClick()
	FindlyaTumbler = not FindlyaTumbler;
	FTumblerState("Собиратель трофеев", FindlyaTumbler);
end

function ButtonAutoAttackTumblerClick()
	AutoAttackTumbler = not AutoAttackTumbler;
	FTumblerState("Автоатака", AutoAttackTumbler);
end



function FTumblerState(TumblerName, TumblerState)
	if (TumblerState) then
		print("|cff00ff00"..TumblerName.." включен|r");
	else
		print("|cff888888"..TumblerName.." отключен|r");
	end
end

function ButtonTumblerClick()
	HelperEnabled = not HelperEnabled;
	if (HelperEnabled) then
		print "|cff00ff00Поддержка включена|r";
	else
		print "|cffff0000Поддержка отключена|r";
	end
end

function ButtonReloadUIClick()
	if (UnitAffectingCombat("player")) then
		print "Нельзя перезагружать интерфейс в бою";
		return;
	end
	ReloadUI();
end

local BindingSpells = 
{
19574, 207068, 131894, 34026, 217200, 193455, 109304, 193530, 2643
};

local BindingMacroses = 
{
["Собиратель трофеев Финдля"] = "/use Собиратель трофеев Финдля",
["Автоатака"] = "/startattack",
["Камень здоровья"] = "/use Камень здоровья"
};

local Targets = 
{
	"player", "target", "mouseover", "targettarget", "party1", "party2", "party3", "party4", "party1target", "party2target", "party3target", "party4target", "pet", "arena1", "arena2", "arena3", "arena4", "arena5", "raid1", "raid2", "raid3", "raid4", "raid5", "raid6", "raid7", "raid8", "raid9", "raid10", "raid11", "raid12", "raid13", "raid14", "raid15", "raid16", "raid17", "raid18", "raid19", "raid20", "raid21", "raid22", "raid23", "raid24", "raid25", "raid26", "raid27", "raid28", "raid29", "raid30", "raid31", "raid32", "raid33", "raid34", "raid35", "raid36", "raid37", "raid38", "raid39", "raid40", "raid1target", "raid2target", "raid3target", "raid4target", "raid5target", "raid6target", "raid7target", "raid8target", "raid9target", "raid10target", "raid11target", "raid12target", "raid13target", "raid14target", "raid15target", "raid16target", "raid17target", "raid18target", "raid19target", "raid20target", "raid21target", "raid22target", "raid23target", "raid24target", "raid25target", "raid26target", "raid27target", "raid28target", "raid29target", "raid30target", "raid31target", "raid32target", "raid33target", "raid34target", "raid35target", "raid36target", "raid37target", "raid38target", "raid39target", "raid40target"
}

function version7()
	local version, build, date, tocversion = GetBuildInfo();
	return (string.find(version, "^7%."))
end

function InitCommands()
	ButtonCounter = -1;
	for i2, BindingSpell in ipairs(BindingSpells) do
		RegisterSpell(BindingSpell, "focus");
	end
	
	for BindingMacrosKey, BindingMacros in pairs(BindingMacroses) do
		RegisterMacros(BindingMacrosKey, BindingMacros);
	end		
	
	for i2, Target in ipairs(Targets) do
		RegisterMacros("Focus"..Target, "/focus "..Target)	
	end
end

SendDataCounter = 0;
function SendData(Cast1, Cast2)
	local code1 = 0; -- XOR от других кодов НЕЧЕТНЫХ
	local code2 = 0; -- XOR от других кодов ЧЕТНЫХ
	local code3 = 0; -- Счетчик
	local code4 = 0; -- заклинание 1
	local code5 = 0; -- заклинание 2
	local code6 = 0;
	
	SendDataCounter = SendDataCounter + 1;
	if (SendDataCounter == 255) then SendDataCounter = 0; end
	code3 = SendDataCounter;
	
	if (SpellCodes[Cast1] ~= nil) then
		code4 = SpellCodes[Cast1];
	end
	
	if (SpellCodes[Cast2] ~= nil) then
		code5 = SpellCodes[Cast2];
	end

	code1 = bit.bxor(42, code3, code5);
	code2 = bit.bxor(42, code4, code6);

	if version7() then
		cmd0:SetColorTexture(code1/255,code2/255,code3/255);	
		cmd1:SetColorTexture(code4/255,code5/255,code6/255);
	else
		cmd0:SetTexture(code1/255,code2/255,code3/255);	
		cmd1:SetTexture(code4/255,code5/255,code6/255);
	end	
end

keys = {  "F2", "F3", "F5", "F6", "F7", "F8", "F9", "F10", "F11", "F12", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "T", "Y", "U", "I", "O", "P", "G", "H", "J", "K", "L", "Z", "X", "C", "V", "B", "N", "M" } 
ButtonCounter = -1;
blackdpsBindingDebug = 1;

function GetNewButton(SpellName)

	local ButtonName = "BlackDpsSpell"..ButtonCounter.."_"..SpellName;
	local ButtonName = "BlackDpsMacro"..ButtonCounter;
	
	local passed = 1
	local HotKey = ""
	repeat
		passed = 1
		ButtonCounter = ButtonCounter+1;
		local Mod = ButtonCounter % 6;
		local Cell = (ButtonCounter-Mod) / 6+1;
	
	

		if Mod == 0 then HotKey = "CTRL-"
			elseif Mod == 1 then HotKey = "ALT-"
			elseif Mod == 2 then HotKey = "SHIFT-"
			elseif Mod == 3 then HotKey = "ALT-SHIFT-"
			elseif Mod == 4 then HotKey = "CTRL-SHIFT-"
			elseif Mod == 5 then HotKey = "ALT-CTRL-"
			else  HotKey = ""
		end	

		HotKey = HotKey..keys[Cell];
		local action = GetBindingByKey(HotKey)
		if (action ~= nil) then
			local key1, key2 = GetBindingKey(action);
			if (key1) then
				if (key1 == HotKey) then passed = 0; end; end;
			if (key2) then
				if (key2 == HotKey) then passed = 0; end; end;
			if (blackdpsBindingDebug == 1 and passed == 0) then print("пропуск "..HotKey..": "..action) end
		end
    until passed == 1
	
	local ButtonForSpell = CreateFrame("Button", ButtonName, UIParent, "SecureActionButtonTemplate");
	
	SetBindingClick(HotKey, ButtonName);


	SpellCodes[SpellName] = ButtonCounter+1;
	if (blackdpsBindingDebug == 1 and not string.find(SpellName, "raid"))  then print("bind "..HotKey..": "..SpellName) end
	
	return ButtonForSpell;
end

function RegisterSpell(SpellName, SpellTarget)
	if SpellCodes[SpellName] ~= nil then AddInformationDebugText("Пропущена повторная регистрация заклинания "..SpellName.." "..SpellTarget); return ;end;
	local ButtonForSpell = GetNewButton(SpellName);

	ButtonForSpell:SetAttribute("type", "spell");
	ButtonForSpell:SetAttribute("spell", GetSpellInfo(SpellName));
	ButtonForSpell:SetAttribute("unit", SpellTarget);
end


function RegisterMacros(MacroName, MacroText)	
	if SpellCodes[MacroName] ~= nil then AddInformationDebugText("Пропущена повторная регистрация макроса "..SpellName.." "..SpellTarget); return ;end;
	local ButtonForSpell = GetNewButton(MacroName);

	ButtonForSpell:SetAttribute("type", "macro");
	ButtonForSpell:SetAttribute("macrotext", MacroText);	
end

SLASH_BLACKDPS1 = '/blackdps';
local function handler(msg, editbox)
	if  string.upper(msg) == "ON" then
		HelperEnabled = true;
		return;
	end

	if  string.upper(msg) == "OFF" then
		HelperEnabled = false;
		return;
	end

	if  string.upper(msg) == "SWITCH" then
		HelperEnabled = not HelperEnabled;
		return;
	end

	local OnPattern = "ON (%d+)"
	if string.find(string.upper(msg), OnPattern) then
		Timers["NEEDOFF"] = string.upper(msg):match(OnPattern) / 1000;
		HelperEnabled = true;
		NEEDOFF = true;
		return;
	end

	local OffPattern = "OFF (%d+)"
	if string.find(string.upper(msg), OffPattern) then
		Timers["NEEDON"] = string.upper(msg):match(OffPattern) / 1000;
		HelperEnabled = false;
		NEEDON = true;
		return;
	end

	local CmdPattern = "CMD (%d+) (%a+)"
	if string.find(string.upper(msg), CmdPattern) then
		local duration, cmd = string.upper(msg):match(CmdPattern);
		Timers["CMD_"..cmd] = duration / 1000;
		print("'"..cmd.."' on "..duration);
		return;
	end

	local Pattern;
	
	Pattern = "ON (.*)"
	if string.find(string.upper(msg), Pattern) then
		local Name = string.upper(msg):match(Pattern);
		SwitchTumbler(Name, true)
		return;
	end

	Pattern = "OFF (.*)"
	if string.find(string.upper(msg), Pattern) then
		print(string.upper(msg));
		local Name = string.upper(msg):match(Pattern);
		print(Name);
		SwitchTumbler(Name, false)
		return;
	end

	Pattern = "SWITCH (.*)"
	if string.find(string.upper(msg), Pattern) then
		local Name = string.upper(msg):match(Pattern);
		ReversTumbler(Name)
		return;
	end

	print("неверный формат параметров макроса /blackdps")
end

--/BLACKDPS SWITCH F1
--/BLACKDPS CMD 100 asd

F1Tumbler = false;
F2Tumbler = false;
F3Tumbler = false;
F4Tumbler = false;
AutoMountTumbler = false;
FindlyaTumbler = false;


function SwitchTumbler(Name, State)
	local Tumbler;
	if  Name == "F1" then 
		F1Tumbler = State
    elseif Name == "F2" then 
		F2Tumbler = State
    elseif Name == "F3" then 
		F3Tumbler = State
    elseif Name == "F4" then 
		F4Tumbler = State
    elseif Name == "M" then 
		AutoMountTumbler = State
    elseif Name == "F" then 
		FindlyaTumbler = State
    elseif Name == "A" then 
		AutoAttackTumbler = State
	else
		print("Неизвестный переключатель "..Name);
		return;
	end

	FTumblerState(Name);
end

function ReversTumbler(Name, State)
	local Tumbler;
	if  Name == "F1" then 
		F1Tumbler = not F1Tumbler
		FTumblerState(Name, F1Tumbler);
    elseif Name == "F2" then 
		F2Tumbler = not F2Tumbler
		FTumblerState(Name, F2Tumbler);
    elseif Name == "F3" then 
		F3Tumbler = not F3Tumbler
		FTumblerState(Name, F3Tumbler);
    elseif Name == "F4" then 
		F4Tumbler = not F4Tumbler
		FTumblerState(Name, F4Tumbler);
    elseif Name == "M" then 
		AutoMountTumbler = not AutoMountTumbler
		FTumblerState(Name, AutoMountTumbler);
    elseif Name == "F" then 
		FindlyaTumbler = not FindlyaTumbler
		FTumblerState(Name, FindlyaTumbler);
    elseif Name == "A" then 
		AutoAttackTumbler = not AutoAttackTumbler
		FTumblerState(Name, AutoAttackTumbler);
	else
		print("Неизвестный переключатель "..Name);
		return;
	end
end

function SpellSelector()

if (((((F1Tumbler and 1 or 0) == 1)and((UnitAffectingCombat("player") and 1 or 0) == 1)))) then
if ((((UnitPower("player", SPELL_POWER_FOCUS ))>=50))) then
if (UnitCanAttack("player", "target") and CanCastUnit(19574, "target",false)) then
return 19574, "target";
end
end

if (UnitCanAttack("player", "target") and CanCastUnit(207068, "target",false)) then
return 207068, "target";
end
if (UnitCanAttack("player", "target") and CanCastUnit(131894, "target",false)) then
return 131894, "target";
end
if (UnitCanAttack("player", "target") and CanCastUnit(34026, "target",false)) then
return 34026, "target";
end
if (UnitCanAttack("player", "target") and CanCastUnit(217200, "target",false)) then
return 217200, "target";
end
if ((((GetLastCD("Звериный гнев")>=3)and((UnitPower("player", SPELL_POWER_FOCUS ))>=35)))) then
if (UnitCanAttack("player", "target") and CanCastUnit(193455, "target",false)) then
return 193455, "target";
end
end

if ((((((UnitHealth("player"))*100/(UnitHealthMax("player")))<40)and(((UnitHealth("pet"))*100/(UnitHealthMax("pet")))==15)))) then
if (CanCastUnit(109304, "player",false)) then
return 109304, "player";
end
end

if (((((UnitHealth("player"))*100/(UnitHealthMax("player")))<=25))) then
if (GetItemLastCD("Камень здоровья") == 0) then return "Камень здоровья", "player" end;

end

end

if (((((F2Tumbler and 1 or 0) == 1)and((UnitAffectingCombat("player") and 1 or 0) == 1)))) then
if ((((UnitPower("player", SPELL_POWER_FOCUS ))>=50))) then
if (UnitCanAttack("player", "target") and CanCastUnit(19574, "target",false)) then
return 19574, "target";
end
end

if (((max(GetBuffRemainTime("player", "Звериный гнев",0))>=14))) then
if (UnitCanAttack("player", "target") and CanCastUnit(193530, "target",false)) then
return 193530, "target";
end
end

if (UnitCanAttack("player", "target") and CanCastUnit(207068, "target",false)) then
return 207068, "target";
end
if (UnitCanAttack("player", "target") and CanCastUnit(131894, "target",false)) then
return 131894, "target";
end
if (UnitCanAttack("player", "target") and CanCastUnit(34026, "target",false)) then
return 34026, "target";
end
if (UnitCanAttack("player", "target") and CanCastUnit(217200, "target",false)) then
return 217200, "target";
end
if ((((UnitPower("player", SPELL_POWER_FOCUS ))>=55))) then
if (UnitCanAttack("player", "target") and CanCastUnit(2643, "target",false)) then
return 2643, "target";
end
end

end



end

SlashCmdList["BLACKDPS"] = handler;

